#ifndef INC_GTSCROLLER_H
#define INC_GTSCROLLER_H

#include "gtmanager.h"
#include "gtcblist.h"

/************************************************************************\
*
* GtScroller class header.
*
* $Ident: This file is part of the 'Gt-library' 1.0.0 $
* $Copyright: (C) 1997 by Gran Gustafsson $
*
\************************************************************************/

/* Type of callback data */
typedef struct GtScrollerCD
{
	long value;
	sbool drag;
} GtScrollerCD;


/* Internal flags */
#define GTSF_REDUCE		0x01
#define GTSF_REPDRAG	0x02
#define GTSF_PULSE		0x04

class GtKnob;

class GtScroller : public GtManager
{
public:
		/* Standard */
	GtScroller(void);
	sbool Init(char *n,GtManager *p,GtTag *tgs);
	sbool Set(GtTag *tgs);
	void Get(GtTag *tgs);
	char *GetClass(void) { return("GtScroller"); }
	sbool IsSubClassOf(char *cn);
		/* Instance checks */
	sbool IsManager(void) { return(TRUE); }
		/* Child management */
	sbool AddChild(GtWidget *o,ulong pos);
		/* Child requests */
	void MoveSizeReq(GtWidget *obj,word xp,word yp,word xs,word ys);
		/* Layout */
	void Relayout(void);
		/* Values */
	void SetEMask(ulong em);
		/* Callbacks */
	void AddCB(ulong tag,GtCallB cb,GtUDPtr ud);
	void RemCB(ulong tag,GtCallB cb);
		/* Notify */
	void Notify(ulong tag);
protected:
		/* Internal methods */
	void Layout(void);
	sbool Draw(XEvent *xe);
	sbool Mouse(XEvent *xe);
protected:
		/* Instance variables */
	GtCBList chg;
	GtKnob *knob;
	long start,val;
	ulong range,rrange,page;
	word knpos,knsz,kmxs,kmys;
	ubyte orient,ftype,sflags,ibw,ibdrw,bdrw;
};

extern GtScroller *GtMkScroller(char *n,GtManager *p,GtTag *tgs);
extern GtScroller *GtMkScroller(char *n,GtManager *p,ulong tag,...);

#endif /* INC_GTSCROLLER_H */
